function [] = ResavanjeSistema(B,c,Eps,X)

% Procena potrebnog broja iteracija

format long


if max([max(sum(abs(B)')) max(sum(abs(B))) sum(sum(B.^2))^0.5])<1
    OutFile=fopen('rezultat.txt','a');
    fprintf(OutFile,'\n');
    fprintf(OutFile,'\n');
    fprintf(OutFile,'Potreban broj iteracija:');
    fprintf(OutFile,'\n');
    
    %disp(' '); 
    %disp(' '); 
    %disp('Potreban broj iteracija:'); 
    %disp(' ');
    
    %Upotrebom uniformne norme
    UnifNorm_B=max(sum(abs(B)'));
    UnifNorm_c=max(abs(c));
    Unif_k=ceil(log(Eps*(1-UnifNorm_B)/UnifNorm_c)/log(UnifNorm_B)-1);

    fprintf(OutFile,'- prema uniformnoj normi: ');
    fprintf(OutFile,'%6.1f\n', Unif_k);    
    
    %disp(['- prema uniformnoj normi: ' num2str(Unif_k)]);

    %Upotrebom apsolutne norme
    AbsNorm_B=max(sum(abs(B)));
    AbsNorm_c=max(sum(abs(c)));
    Abs_k=ceil(log(Eps*(1-AbsNorm_B)/AbsNorm_c)/log(AbsNorm_B)-1);

    fprintf(OutFile,'- prema apsolutnoj normi: ');
    fprintf(OutFile,'%6.1f\n', Abs_k);    

    %disp(['- prema apsolutnoj normi: ' num2str(Abs_k)]);

    %Upotrebom euklidske norme
    EucNorm_B=sum(sum(B.^2))^0.5;
    EucNorm_c=sum(sum(c.^2))^0.5;
    Euc_k=ceil(log(Eps*(1-EucNorm_B)/EucNorm_c)/log(EucNorm_B)-1);

    fprintf(OutFile,'- prema euklidskoj normi: ');
    fprintf(OutFile,'%6.1f\n', Euc_k);    

    %disp(['- prema euklidskoj normi: ' num2str(Euc_k)]); disp(' ');

    k=min([Unif_k Abs_k Euc_k]);

    fprintf(OutFile,'Biramo najblazi kriterijum sa najmanjim brojem iteracija: k=');
    fprintf(OutFile,'%6.1f\n', k);    
    
    %disp(['Biramo najblazi kriterijum sa najmanjim brojem iteracija: k=' num2str(k)]);

    fclose(OutFile);

else p=min([max(sum(abs(B)')) max(sum(abs(B))) sum(sum(B.^2))^0.5]);
    if p<1 
        k=ceil(log(Eps*(1-p)/p)/log(p)-1);

        OutFile=fopen('rezultat.txt','a');
        fprintf(OutFile,'\n');
        fprintf(OutFile,'\n');
        fprintf(OutFile,'Izabrani broj iteracija prema minimalnoj normi je: ');
        fprintf(OutFile,'%6.1f\n', k);    
        fclose(OutFile);
        
        %disp(' '); 
        %disp(' '); 
        %disp(['Izabrani broj iteracija prema minimalnoj normi je: ' num2str(k)]);
    else k=30;
    end;
end;

% Resavanje sistema kroz iteracije
Resenje=X';
for br=1:k
    Xtek=Resenje(br, :)';
    Resenje(br+1, :)=(B*Xtek+c)';
end;

% Resenje 2
Anew=B-eye(size(B));
D=Anew.*eye(size(Anew));
b=-c;
Dinv=inv(D);

Resenje2=X';
for br=1:k
    X=Resenje2(br, :)';
    Resenje2(br+1, :)=Dinv*(D-Anew)*X+Dinv*b;
end
Resenje2;

Resenje
Resenje2

OutFile=fopen('rezultat.txt','a');
fprintf(OutFile,'\n');
fprintf(OutFile,'\n');
fprintf(OutFile,'Iterativni proces prema zadatoj tacnosti:');
fprintf(OutFile,'\n');

tmp=size(Resenje,2);
if tmp==2
    fprintf(OutFile,'%6.8f   %6.8f\n', Resenje2');
end
if tmp==3
    fprintf(OutFile,'%6.8f   %6.8f   %6.8f\n', Resenje2');
end
if tmp==4
    fprintf(OutFile,'%6.8f   %6.8f   %6.8f   %6.8f\n', Resenje2');
end
fclose(OutFile);

%disp(' '); 
%disp(' '); 
%disp('Iterativni proces prema zadatoj tacnosti:'); 
%disp(' '); 
%disp(Resenje);
