%	DISPLAY A MOZDA TRANSPONOVANO I TA CUDA
%	DISPLAY AMOD MOZDA TRANSPONOVANO I TA CUDA







function [] = ProveraDominacije(B,c,Eps,X)
A=B-eye(size(B));
format short g
%Provera da li je matrica u startu dijagonalno dominantna
if sum(sum(abs(A.*~eye(size(A,1)))') < sum(abs(A).*eye(size(A,1)))) == size(A,1)
    OutFile=fopen('rezultat.txt','a');
   
    fprintf(OutFile,'\n');
    fprintf(OutFile,'Matrica sistema A JESTE dijagonalno dominantna.');
    fprintf(OutFile,'Dakle, DOVOLJAN uslov konvergencije iteracionog procesa je ispunjen.');
    fprintf(OutFile,'\n');
    fprintf(OutFile,'\n');
    
    fclose(OutFile);
    
    %disp(' ');
    %disp('         Matrica sistema A JESTE dijagonalno dominantna!');
    %disp('Dakle, DOVOLJAN uslov konvergencije iteracionog procesa je ispunjen!!!');
    %disp(' ');
    %disp(' ');
    
    ResavanjeSistema(B,c,Eps,X)
    return
end

% Provera da li se matrica (koja nije dijagonalno dominantna) moze uciniti
% dijagonalno dominantnom putem izmene redosleda jednacina u sistemu
[a,b]=max(abs(A)');
if sum(sum(abs(A)')-abs(a) < abs(a)) ~= size(A,1)
    
    OutFile=fopen('rezultat.txt','a');
   
    fprintf(OutFile,'\n');
    fprintf(OutFile,'Matrica sistema A NIJE dijagonalno dominantna i izmenom redosleda jednacina u sistemu se NE moze uciniti dijagonalno dominantnom.');
    fprintf(OutFile,'\n');
    fprintf(OutFile,'\n');
    
    fclose(OutFile);

    
    
    %disp(' ');
    %disp('  Matrica sistema A NIJE dijagonalno dominantna i izmenom redosleda jednacina');
    %disp('           u sistemu se NE moze uciniti dijagonalno dominantnom!');
    %disp(' ');disp(' ');
   
    ProveraNorme(B,c,Eps,X);
    return
end
for br1 = 1:length(b)-1
    for br2 = br1+1:length(b)
        if b(br1) == b(br2)
                OutFile=fopen('rezultat.txt','a');
   
                fprintf(OutFile,'\n');
                fprintf(OutFile,'Matrica sistema A NIJE dijagonalno dominantna i izmenom redosleda jednacina u sistemu se NE moze uciniti dijagonalno dominantnom.');
                fprintf(OutFile,'\n');
                fprintf(OutFile,'\n');
    
                fclose(OutFile);
            
            
                %disp(' ');
                %disp('  Matrica sistema A NIJE dijagonalno dominantna i izmenom redosleda jednacina');
                %disp('             u sistemu se NE moze uciniti dijagonalno dominantnom!!');
                %disp(' ');disp(' ');
            
                ProveraNorme(B,c,Eps,X);
            return
        end
    end
end

% Posto smo proverili da se matrica MOZE korigovati da postane dijagonalno 
% dominantna, sada pristupamo njenoj korekciji tako sto menjamo redosled 
% jednacina u sistemu
for br = 1:length(b)
    Amod(b(br), :) = A(br, :);
end

OutFile=fopen('rezultat.txt','a');
   
fprintf(OutFile,'\n');
fprintf(OutFile,'Matrica sistema A NIJE dijagonalno dominantna ALI se izmenom redosleda jednacina u sistemu MOZE uciniti dijagonalno dominantnom:');
fprintf(OutFile,'\n');
fprintf(OutFile,'\n');
fprintf(OutFile,'- Originalna matrica:');
fprintf(OutFile,'\n');
tmp=size(A,2);
if tmp==2
    fprintf(OutFile,'%6.4f   %6.4f\n', A');
end
if tmp==3
    fprintf(OutFile,'%6.4f   %6.4f   %6.4f\n', A');
end
if tmp==4
    fprintf(OutFile,'%6.4f   %6.4f   %6.4f   %6.4f\n', A');
end
fprintf(OutFile,'\n');
fprintf(OutFile,'- Modifikovana matrica:');
fprintf(OutFile,'\n');
tmp=size(Amod,2);
if tmp==2
    fprintf(OutFile,'%6.4f   %6.4f\n', Amod');
end
if tmp==3
    fprintf(OutFile,'%6.4f   %6.4f   %6.4f\n', Amod');
end
if tmp==4
    fprintf(OutFile,'%6.4f   %6.4f   %6.4f   %6.4f\n', Amod');
end
fprintf(OutFile,'\n');
fprintf(OutFile,'Dakle, DOVOLJAN uslov konvergencije iteracionog procesa je ispunjen.');
fprintf(OutFile,'\n');
fprintf(OutFile,'\n');

fclose(OutFile);

%disp(' ');
%disp('  Matrica sistema A NIJE dijagonalno dominantna ALI se izmenom redosleda jednacina');
%disp('                u sistemu MOZE uciniti dijagonalno dominantnom:');
%disp(' ');
%disp(' ');
%disp('- Originalna matrica:');
%disp(' ');
%disp(A);
%disp(' ');
%disp('- Modifikovana matrica:');
%disp(' ');
%disp(Amod);
%disp('Dakle, DOVOLJAN uslov konvergencije iteracionog procesa je ispunjen!!!');disp(' ');disp(' ');

ResavanjeSistema(B,c,Eps,X)

